<?php
/*
	This is the font library block, usable inside of the website. Made for /fonts
*/
function randomFonts($maxFonts = 4) {
	// generates html to display $maxFonts random fonts.
	require_once('config.php');
	require_once('includes/sampleText.php');
	$fontsPerPage = 25;
		
	$db = new mysqli($cfg['mysql']['hostname'],$cfg['mysql']['username'],$cfg['mysql']['password'],$cfg['mysql']['database']);
	if ($db->connect_errno) {
		return false;
	}

	$fonts = array();
	$sql = <<< SQL_SELECT_FONTS_BY_FAMILY
		SELECT
		`family`.`name`,
		`family`.`directory`,
		`family`.`license`,
		`family`.`source`,
		`family`.`css`,
		`font`.`weight`,
		`font`.`style`,
		`font`.`filename`
		FROM `family`
		LEFT JOIN `font`
		ON `family`.`name` = `font`.`family`
		AND `family`.`swatch_weight` = `font`.`weight`
		AND `family`.`swatch_style` = `font`.`style`
		ORDER BY `family`.`name` ASC
		/* ORDER BY RAND() */
SQL_SELECT_FONTS_BY_FAMILY;
	if ($maxFonts != -1) $sql .= " LIMIT {$maxFonts}";
	if ($result = $db->query($sql)) {
		$last_done = "";
		$swatches = $cssFiles = $modalDialogs = array();
		while ($row = $result->fetch_assoc()) {
			if ($row['name'] == $last_done) continue;
			$last_done = $row['name'];
			echo <<<JS
JS;
			$swatchClickURL = "/font/{$row['directory']}";
			$swatches[$row['directory']] = <<< FONT_SWATCH
				<li class="swatch swatch-small swatch-lazyload" id="swatch-{$row['directory']}"
					data-family="{$row['name']}" data-directory="{$row['directory']}"
					data-filename="{$row['filename']}" data-style="{$row['style']}" data-weight="{$row['weight']}">
					<div class="fontTitle" style="font-family: '{$row['name']}';">
						<a class="fontTitleText" href="{$swatchClickURL}">{$row['name']}</a>
					</div>
					<span class="buttonsLeft">
						<span><a href="/license/{$row['license']}" class="fontLicense">{$row['license']}</a></span>
					</span>
					<span class="buttonsRight">
						<button class="use css" data-font="{$row['directory']}">CSS</button>
						<!-- <button class="use dl" data-font="{$row['directory']}">DL</button> -->
					</span>
				</li>
FONT_SWATCH;
			$sampleText = sampleText('sentence');
			$modalDialogs[$row['directory']] = <<< MODAL_DIALOG
				<div id="modal-{$row['directory']}" class="modal fade">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
								<h4 class="modal-title">{$row['name']}</h4>
							</div>
							<div class="modal-body">
								<p class="modal-sample-sentence" style="font-family: '{$row['name']}';">{$sampleText}</p>
								<pre class="css-code">{$row['css']}</pre>
							</div>
							<div class="modal-footer">
								<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
								<button type="button" class="btn btn-primary">Save changes</button>
							</div>
						</div>
					</div>
				</div>
MODAL_DIALOG;
		}
		echo <<<LISTPARAMS
			<div class="listContainer" id="listContainer">
				<div class="listParams">
					<input class="search" placeholder="Search" />
					<button class="sort" data-sort="fontTitleText">Title</button>
					<button class="sort" data-sort="fontLicense">License</button>
				</div>
LISTPARAMS;
		echo "<ul class='list featuredContainer'>";
		echo implode("", $swatches);
		echo "</ul>"; // .list
		echo "<ul class='pagination centered'></ul>"; // pagination controls
		echo "<div class='loading'></div>";
		echo "</div>"; // .listContainer
		echo <<<SCRIPT
			<script>
				// $('#listContainer').addClass("hidden-loading");
				
				
				$.waypoints.scrollThrottle = 250;

			
				var fontList = new List('listContainer', {
					valueNames: [ 'fontTitleText', 'fontLicense' ],
					page: {$fontsPerPage},
					plugins: [ ListPagination({}) ],
				});
				fontList.on('updated',function() {
					$('.listContainer > .loading').show();
					$('.swatch-lazyload:visible').waypoint({
						offset: document.documentElement.clientHeight * 2,
						triggerOnce: true,
						handler: function() {
							loadFontFace(
								$(this).attr('data-family'),
								$(this).attr('data-directory'),
								$(this).attr('data-filename'),
								$(this).attr('data-style'),
								$(this).attr('data-weight')
							);
						}
					});
					
					$('.use.css').click(function() {
						var font = $(this).attr('data-font');
						$('#modal-'+font).modal();
					});
					
					$('.css-code').click(function() {
						selectText(this);
					});
					
					$('.listContainer > .loading').hide();
				});
				
				fontList.update();
			</script>
SCRIPT;
		echo implode("", $modalDialogs);
		
	}
}

?>
